#include <stdio.h>
#include <stdlib.h>
#include "stk.h"

/* funzione ausiliaria per segnalare errori */
static void manageerror(char *s, short code)
{
	fprintf(stderr,"Errore: %s\n",s);
	exit(code);
}

#define BLOCKSIZE	10

void push(stack *s, char e)
{
	/* se abbiamo esaurito l'array buf lo riallochiamo allargato */
	if(s->pos == s->dim) {
		s->dim += BLOCKSIZE;
		if(!(s->buf = realloc(s->buf,s->dim)))                 
			manageerror("Impossibile riallocare lo stack",1);
	}
	s->buf[s->pos++] = e;
}

char pop(stack *s)
{
	if(s->pos)
		return s->buf[--s->pos];
	else
		return EOF;  /* se lo stack e' vuoto ritorniamo EOF */
}

char empty(stack *s)
{
	return !s->pos;
}

/* prima di usare uno stack dobbiamo crearlo, invocando createstack */
stack *createstack(void)
{
	stack *s = malloc(sizeof(stack));
	
	if(!s)
		manageerror("Impossibile creare stack",2);
	if(!(s->buf = malloc(s->dim = BLOCKSIZE)))
		manageerror("Impossibile creare stack",3);
	s->pos = 0;
	return s;
}

/* libera la memoria occupata dallo stack */
void destroystack(stack *s)
{
	if(s) {
		free(s->buf);
		free(s);
	}
}
